function y = Afun(x, tol, A, M1, M2, M3)
% Multiplies the Control matrix
%   [M1      0   A';
%    0       M2   M3';
%    A   M3    0]
% by the blocked tt_tensor x = {x{1},x{2},x{3}}.
y = x;

% First line
y11 = amen_mv(M1, x{1}, tol, 'y0', x{1}, 'fkick', true, 'verb', 0);
y12 = amen_mv(A', x{3}, tol, 'y0', x{3}, 'fkick', true, 'verb', 0);
y{1} = y11+y12;

% Second line
hans = M3'*x{3};
gretel  = M2*x{2};
hans = tt_reshape(hans , gretel.n);
y{2} = gretel + hans;

% Third line
y31 = amen_mv(A, x{1}, tol, 'y0', x{1}, 'fkick', true, 'verb', 0);
y32 = M3*tt_reshape(x{2}, M3.m);
y32 = round(y32, tol);
y{3} = y31+y32;

y{1} = round(y{1}, tol);
y{2} = round(y{2}, tol);
y{3} = round(y{3}, tol);

end