function y = Pfun(x, tol, M1, invM1, invM2, S1, S2)
% Multiplies the preconditioner
%   [invM1    0          0;
%     0     invM2        0;
%     0       0    inv(S2)*M1*inv(S1)]
% by the blocked tt_tensor x = {x{1},x{2},x{3}}.

y = x;

% First line
y{1} = invM1*y{1};
y{1} = round(y{1}, tol);
% Second line
y{2} = invM2*y{2};
y{2} = round(y{2}, tol);

% Third line
y{3} = amen_solve2(S1, y{3}, tol, 'x0', y{3}, 'verb', 0, 'trunc_norm', 'fro');
y{3} = M1*y{3};
y{3} = round(y{3}, tol);
y{3} = amen_solve2(S2, y{3}, tol, 'x0', y{3}, 'verb', 0, 'trunc_norm', 'fro');

end